#include <iostream>
#include <math.h>
using namespace std;
int main(int argc, char** argv) {
	int n, m, i, j, c, rezultat = 0;
	cin >> n >> m;
	int a[n + 1], b[m + 1];
	for(j = 1; j < m + 1; j++) cin >> b[j];
	cin >> c;
	for(i = 1; i < n + 1; i++) a[i] = i;
	for(i = 0; i < n-m + 1; i++)
	{
		for(j = 1; j < m + 1; j++)
		{
			a[i + b[j]] = a[i + j];
		}
	}
	for(i = 1; i < n+1; i++)
	{
		rezultat += pow(c, i) * a[i];
	}
	cout << rezultat;
	return 0;
}